unit McMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, ComCtrls, Menus, ExtCtrls, OleCtrls, SHDocVw, EmbeddedWB,
  StdCtrls, Buttons, BBSUtils, IdComponent, BoardView, McConfig, ThreadView,
	BrowserView, McTypes, IniFiles;

type
  TMaCherieMainForm = class(TForm)
    BoardView: TBoardViewFrame;
    HorizontalSplitter: TSplitter;
    RightPanel: TPanel;
    ThreadView: TThreadViewFrame;
    VerticalSplitter: TSplitter;
    BrowserView: TBrowserViewFrame;
    procedure FormCreate(Sender: TObject);
    procedure BoardViewBoardTreeViewDblClick(Sender: TObject);
	private
		{ Private 錾 }
		FMcConfig: TMaCherieConfig;
	public
		{ Public 錾 }
		procedure BrowserOpen(TabType: TBrowserViewTabType; Thread: T2chThreadIniFile);
		procedure RefreshThread(Thread: T2chThreadIniFile);
  end;

var
  MaCherieMainForm: TMaCherieMainForm;

implementation

uses IdAsyncHTTP, MSHTML, McUtils, IdHTTPHeaderInfo;

{$R *.dfm}

{ TTMaCheriMainForm }

procedure TMaCherieMainForm.FormCreate(Sender: TObject);
var
	Version: string;
	IniFile: TMemIniFile;
begin
	IniFile := nil;
	FMcConfig := TMaCherieConfig.Create;

	FMcConfig.Enter;
	try
		FMcConfig.SetBaseDir(GetCurrentDir);

		{ o[Wǂݍ }
		FMcConfig.VersionInfo.LoadFromFile(Application.ExeName);
		with FMcConfig.VersionInfo do
		begin
			Version := Format('%d.%.2d Build #%d', [Major, Minor, Build]);
			Caption := Caption + ' ' + Version;
			FMcConfig.CommParams.UserAgent := Format('Monazilla/1.00 (MaCherie/%d.%.2d.%.2d)', [Major, Minor, Build]);
		end;

		try
			IniFile := TMemIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
			with FMcConfig.CommParams.ProxyParams do
			begin
				ProxyPort := IniFile.ReadInteger('Browser', 'ProxyPort', 80);
				ProxyServer := IniFile.ReadString('Browser', 'ProxyServer', '');
			end;
		finally
			FreeAndNil(IniFile);
		end;
		FMcConfig.CommParams.ReadTimeOut := 30000;
	finally
		FMcConfig.Leave;
	end;

	BoardView.BoardLoadFromFile(FMcConfig.GetBaseDir + BOARD_2CHANNEL_BRD, btMain);
	if FileExists(FMcConfig.GetBaseDir + BOARD_OTHER_BRD) then
		BoardView.BoardLoadFromFile(FMcConfig.GetBaseDir + BOARD_OTHER_BRD, btOther);

	ThreadView.Config := FMcConfig;
	BrowserView.Config := FMcConfig;
end;

procedure TMaCherieMainForm.BoardViewBoardTreeViewDblClick(
	Sender: TObject);
var
	SelBoard: string;
begin
	SelBoard := BoardView.SelectedBoard;
	if SelBoard <> '' then
	begin
		ThreadView.BoardName := BoardView.SelectedBoardName;
		ThreadView.SelectedBoard := SelBoard;
	end;
end;

procedure TMaCherieMainForm.BrowserOpen(TabType: TBrowserViewTabType;
	Thread: T2chThreadIniFile);
begin
	BrowserView.BrowserOpen(TabType, Thread);
end;

procedure TMaCherieMainForm.RefreshThread(Thread: T2chThreadIniFile);
begin
	if Thread.ListItem <> nil then
		ThreadView.RefreshListItem(TListItem(Thread.ListItem), Thread);
end;

end.

